## Sync

Since Ant 1.6

### Description

Synchronize a target directory from the files defined in one or more filesets.

Any file in the target directory that has not been matched by at least one of the nested filesets gets removed. I.e. if you exclude a file in your sources and a file of that name is present in the target dir, it will get removed from the target.

### Parameters

Attribute | Description | Required
todir | the target directory to sync with the filesets | Yes
overwrite | Overwrite existing files even if the destination files are newer. | No; defaults to false.
includeEmptyDirs | Copy any empty directories included in the FileSet(s). | No; defaults to true.
failonerror | Log a warning message, but do not stop the build, when one of the nested filesets points to a directory that doesn't exist. | No; defaults to true.
verbose | Log the files that are being copied. | No; defaults to false.
granularity | The number of milliseconds leeway to give before deciding a file is out of date. This is needed because not every file system supports tracking the last modified time to the millisecond level. Default is 0 milliseconds, or 2 seconds on DOS systems. This can also be useful if source and target files live on separate machines with clocks being out of sync. since Ant 1.6.2. | No.

### Parameters specified as nested elements

#### fileset

FileSets are used to select sets of files and directories.

#### preserveInTarget

Specifies files or directories that should be kept in the target directory even if they are not present in one of the source directories.

This nested element is like a FileSet except that it doesn't support the dir attribute and the usedefaultexcludes attribute defaults to false.

### Examples

>     <sync todir="site">
>       <fileset dir="generated-site"/>
>     </sync>

overwrites all files in site with newer files from generated-site, deletes files from site that are not present in generated-site.

>     <sync todir="site">
>       <fileset dir="generated-site"/>
>       <preserveintarget>
>         <include name="**/CVS/**"/>
>       </preserveintarget>
>     </sync>

overwrites all files in site with newer files from generated-site, deletes files from site that are not present in generated-site but keeps all files in any CVS sub-directory.

Copyright © 2003-2005 The Apache Software Foundation. All rights Reserved.